/*! AdminLTE app.js
 * ================
 * Main JS application file for AdminLTE v2. This file
 * should be included in all pages. It controls some layout
 * options and implements exclusive AdminLTE plugins.
 *
 * @Author  Almsaeed Studio
 * @Support <http://www.almsaeedstudio.com>
 * @Email   <support@almsaeedstudio.com>
 * @version 2.3.2
 * @license MIT <http://opensource.org/licenses/MIT>
 */
function _init() {
    "use strict";
    $.AdminLTE.layout = {
        activate: function () {
            var a = this;
            a.fix(), a.fixSidebar(), $(window, ".wrapper").resize(function () {
                a.fix(), a.fixSidebar()
            })
        }, fix: function () {
            var a = $(".main-header").outerHeight() + $(".main-footer").outerHeight(), b = $(window).height(), c = $(".sidebar").height();
            if ($("body").hasClass("fixed"))$(".content-wrapper, .right-side").css("min-height", b - $(".main-footer").outerHeight()); else {
                var d;
                b >= c ? ($(".content-wrapper, .right-side").css("min-height", b - a), d = b - a) : ($(".content-wrapper, .right-side").css("min-height", c), d = c);
                var e = $($.AdminLTE.options.controlSidebarOptions.selector);
                "undefined" != typeof e && e.height() > d && $(".content-wrapper, .right-side").css("min-height", e.height())
            }
        }, fixSidebar: function () {
            return $("body").hasClass("fixed") ? ("undefined" == typeof $.fn.slimScroll && window.console && window.console.error("Error: the fixed layout requires the slimscroll plugin!"), void($.AdminLTE.options.sidebarSlimScroll && "undefined" != typeof $.fn.slimScroll && ($(".sidebar").slimScroll({destroy: !0}).height("auto"), $(".sidebar").slimscroll({
                height: $(window).height() - $(".main-header").height() + "px",
                color: "rgba(0,0,0,0.2)",
                size: "3px"
            })))) : void("undefined" != typeof $.fn.slimScroll && $(".sidebar").slimScroll({destroy: !0}).height("auto"))
        }
    }, $.AdminLTE.pushMenu = {
        activate: function (a) {
            var b = $.AdminLTE.options.screenSizes;
            $(document).on("click", a, function (a) {
                a.preventDefault(), $(window).width() > b.sm - 1 ? $("body").hasClass("sidebar-collapse") ? $("body").removeClass("sidebar-collapse").trigger("expanded.pushMenu") : $("body").addClass("sidebar-collapse").trigger("collapsed.pushMenu") : $("body").hasClass("sidebar-open") ? $("body").removeClass("sidebar-open").removeClass("sidebar-collapse").trigger("collapsed.pushMenu") : $("body").addClass("sidebar-open").trigger("expanded.pushMenu")
            }), $(".content-wrapper").click(function () {
                $(window).width() <= b.sm - 1 && $("body").hasClass("sidebar-open") && $("body").removeClass("sidebar-open")
            }), ($.AdminLTE.options.sidebarExpandOnHover || $("body").hasClass("fixed") && $("body").hasClass("sidebar-mini")) && this.expandOnHover()
        }, expandOnHover: function () {
            var a = this, b = $.AdminLTE.options.screenSizes.sm - 1;
            $(".main-sidebar").hover(function () {
                $("body").hasClass("sidebar-mini") && $("body").hasClass("sidebar-collapse") && $(window).width() > b && a.expand()
            }, function () {
                $("body").hasClass("sidebar-mini") && $("body").hasClass("sidebar-expanded-on-hover") && $(window).width() > b && a.collapse()
            })
        }, expand: function () {
            $("body").removeClass("sidebar-collapse").addClass("sidebar-expanded-on-hover")
        }, collapse: function () {
            $("body").hasClass("sidebar-expanded-on-hover") && $("body").removeClass("sidebar-expanded-on-hover").addClass("sidebar-collapse")
        }
    }, $.AdminLTE.tree = function (a) {
        var b = this, c = $.AdminLTE.options.animationSpeed;
        $(a).on("click", "li a", function (d) {
            var e = $(this), f = e.next();
            if (f.is(".treeview-menu") && f.is(":visible") && !$("body").hasClass("sidebar-collapse"))f.slideUp(c, function () {
                f.removeClass("menu-open")
            }), f.parent("li").removeClass("active"); else if (f.is(".treeview-menu") && !f.is(":visible")) {
                var g = e.parents("ul").first(), h = g.find("ul:visible").slideUp(c);
                h.removeClass("menu-open");
                var i = e.parent("li");
                f.slideDown(c, function () {
                    f.addClass("menu-open"), g.find("li.active.treeview").removeClass("active"), i.addClass("active"), b.layout.fix()
                })
            } else e.is(".active") || ($(a).find(".active").each(function (a, b) {
                var c = $(b);
                c.is(".treeview") || c.removeClass("active")
            }), e.parent("li").addClass("active"));
            f.is(".treeview-menu") && d.preventDefault()
        })
    }, $.AdminLTE.controlSidebar = {
        activate: function () {
            var a = this, b = $.AdminLTE.options.controlSidebarOptions, c = $(b.selector), d = $(b.toggleBtnSelector);
            d.on("click", function (d) {
                d.preventDefault(), c.hasClass("control-sidebar-open") || $("body").hasClass("control-sidebar-open") ? a.close(c, b.slide) : a.open(c, b.slide)
            });
            var e = $(".control-sidebar-bg");
            a._fix(e), $("body").hasClass("fixed") ? a._fixForFixed(c) : $(".content-wrapper, .right-side").height() < c.height() && a._fixForContent(c)
        }, open: function (a, b) {
            b ? a.addClass("control-sidebar-open") : $("body").addClass("control-sidebar-open")
        }, close: function (a, b) {
            b ? a.removeClass("control-sidebar-open") : $("body").removeClass("control-sidebar-open")
        }, _fix: function (a) {
            var b = this;
            $("body").hasClass("layout-boxed") ? (a.css("position", "absolute"), a.height($(".wrapper").height()), $(window).resize(function () {
                b._fix(a)
            })) : a.css({position: "fixed", height: "auto"})
        }, _fixForFixed: function (a) {
            a.css({position: "fixed", "max-height": "100%", overflow: "auto", "padding-bottom": "50px"})
        }, _fixForContent: function (a) {
            $(".content-wrapper, .right-side").css("min-height", a.height())
        }
    }, $.AdminLTE.boxWidget = {
        selectors: $.AdminLTE.options.boxWidgetOptions.boxWidgetSelectors,
        icons: $.AdminLTE.options.boxWidgetOptions.boxWidgetIcons,
        animationSpeed: $.AdminLTE.options.animationSpeed,
        activate: function (a) {
            var b = this;
            a || (a = document), $(a).on("click", b.selectors.collapse, function (a) {
                a.preventDefault(), b.collapse($(this))
            }), $(a).on("click", b.selectors.remove, function (a) {
                a.preventDefault(), b.remove($(this))
            })
        },
        collapse: function (a) {
            var b = this, c = a.parents(".box").first(), d = c.find("> .box-body, > .box-footer, > form  >.box-body, > form > .box-footer");
            c.hasClass("collapsed-box") ? (a.children(":first").removeClass(b.icons.open).addClass(b.icons.collapse), d.slideDown(b.animationSpeed, function () {
                c.removeClass("collapsed-box")
            })) : (a.children(":first").removeClass(b.icons.collapse).addClass(b.icons.open), d.slideUp(b.animationSpeed, function () {
                c.addClass("collapsed-box")
            }))
        },
        remove: function (a) {
            var b = a.parents(".box").first();
            b.slideUp(this.animationSpeed)
        }
    }
}
if ("undefined" == typeof jQuery)throw new Error("AdminLTE requires jQuery");
$.AdminLTE = {}, $.AdminLTE.options = {
    navbarMenuSlimscroll: !0,
    navbarMenuSlimscrollWidth: "3px",
    navbarMenuHeight: "200px",
    animationSpeed: 500,
    sidebarToggleSelector: "[data-toggle='offcanvas']",
    sidebarPushMenu: !0,
    sidebarSlimScroll: !0,
    sidebarExpandOnHover: !1,
    enableBoxRefresh: !0,
    enableBSToppltip: !0,
    BSTooltipSelector: "[data-toggle='tooltip']",
    enableFastclick: !0,
    enableControlSidebar: !0,
    controlSidebarOptions: {
        toggleBtnSelector: "[data-toggle='control-sidebar']",
        selector: ".control-sidebar",
        slide: !0
    },
    enableBoxWidget: !0,
    boxWidgetOptions: {
        boxWidgetIcons: {collapse: "fa-minus", open: "fa-plus", remove: "fa-times"},
        boxWidgetSelectors: {remove: '[data-widget="remove"]', collapse: '[data-widget="collapse"]'}
    },
    directChat: {enable: !0, contactToggleSelector: '[data-widget="chat-pane-toggle"]'},
    colors: {
        lightBlue: "#3c8dbc",
        red: "#f56954",
        green: "#00a65a",
        aqua: "#00c0ef",
        yellow: "#f39c12",
        blue: "#0073b7",
        navy: "#001F3F",
        teal: "#39CCCC",
        olive: "#3D9970",
        lime: "#01FF70",
        orange: "#FF851B",
        fuchsia: "#F012BE",
        purple: "#8E24AA",
        maroon: "#D81B60",
        black: "#222222",
        gray: "#d2d6de"
    },
    screenSizes: {xs: 480, sm: 768, md: 992, lg: 1200}
}, $(function () {
    "use strict";
    $("body").removeClass("hold-transition"), "undefined" != typeof AdminLTEOptions && $.extend(!0, $.AdminLTE.options, AdminLTEOptions);
    var a = $.AdminLTE.options;
    _init(), $.AdminLTE.layout.activate(), $.AdminLTE.tree(".sidebar"), a.enableControlSidebar && $.AdminLTE.controlSidebar.activate(), a.navbarMenuSlimscroll && "undefined" != typeof $.fn.slimscroll && $(".navbar .menu").slimscroll({
        height: a.navbarMenuHeight,
        alwaysVisible: !1,
        size: a.navbarMenuSlimscrollWidth
    }).css("width", "100%"), a.sidebarPushMenu && $.AdminLTE.pushMenu.activate(a.sidebarToggleSelector), a.enableBSToppltip && $("body").tooltip({selector: a.BSTooltipSelector}), a.enableBoxWidget && $.AdminLTE.boxWidget.activate(), a.enableFastclick && "undefined" != typeof FastClick && FastClick.attach(document.body), a.directChat.enable && $(document).on("click", a.directChat.contactToggleSelector, function () {
        var a = $(this).parents(".direct-chat").first();
        a.toggleClass("direct-chat-contacts-open")
    }), $('.btn-group[data-toggle="btn-toggle"]').each(function () {
        var a = $(this);
        $(this).find(".btn").on("click", function (b) {
            a.find(".btn.active").removeClass("active"), $(this).addClass("active"), b.preventDefault()
        })
    }), $.Metro.initWidgets()
}), function (a) {
    "use strict";
    a.fn.boxRefresh = function (b) {
        function c(a) {
            a.append(f), e.onLoadStart.call(a)
        }

        function d(a) {
            a.find(f).remove(), e.onLoadDone.call(a)
        }

        var e = a.extend({
            trigger: ".refresh-btn", source: "", onLoadStart: function (a) {
                return a
            }, onLoadDone: function (a) {
                return a
            }
        }, b), f = a('<div class="overlay"><div class="fa fa-refresh fa-spin"></div></div>');
        return this.each(function () {
            if ("" === e.source)return void(window.console && window.console.log("Please specify a source first - boxRefresh()"));
            var b = a(this), f = b.find(e.trigger).first();
            f.on("click", function (a) {
                a.preventDefault(), c(b), b.find(".box-body").load(e.source, function () {
                    d(b)
                })
            })
        })
    }
}(jQuery), function (a) {
    "use strict";
    a.fn.activateBox = function () {
        a.AdminLTE.boxWidget.activate(this)
    }, a.fn.toggleBox = function () {
        var b = a(a.AdminLTE.boxWidget.selectors.collapse, this);
        a.AdminLTE.boxWidget.collapse(b)
    }, a.fn.removeBox = function () {
        var b = a(a.AdminLTE.boxWidget.selectors.remove, this);
        a.AdminLTE.boxWidget.remove(b)
    }
}(jQuery), function (a) {
    "use strict";
    a.fn.todolist = function (b) {
        var c = a.extend({
            onCheck: function (a) {
                return a
            }, onUncheck: function (a) {
                return a
            }
        }, b);
        return this.each(function () {
            "undefined" != typeof a.fn.iCheck ? (a("input", this).on("ifChecked", function () {
                var b = a(this).parents("li").first();
                b.toggleClass("done"), c.onCheck.call(b)
            }), a("input", this).on("ifUnchecked", function () {
                var b = a(this).parents("li").first();
                b.toggleClass("done"), c.onUncheck.call(b)
            })) : a("input", this).on("change", function () {
                var b = a(this).parents("li").first();
                b.toggleClass("done"), a("input", b).is(":checked") ? c.onCheck.call(b) : c.onUncheck.call(b)
            })
        })
    }
}(jQuery), window.isTouchDevice = function () {
    return "ontouchstart"in window || navigator.MaxTouchPoints > 0 || navigator.msMaxTouchPoints > 0
}, $.widget("metro.tile", {
    version: "3.0.0",
    options: {
        effect: "slideLeft", period: 4e3, duration: 700, easing: "doubleSqrt", onClick: function (a) {
        }
    },
    _frames: {},
    _currentIndex: 0,
    _interval: 0,
    _outPosition: 0,
    _size: {},
    _create: function () {
        var a = this.element, b = this.options;
        $.each(a.data(), function (a, c) {
            if (a in b)try {
                b[a] = $.parseJSON(c)
            } catch (d) {
                b[a] = c
            }
        }), this._createTransformTile(), this._createLiveTile(), this._createEvents(), a.data("tile", this)
    },
    _createEvents: function () {
        var that = this, element = this.element, o = this.options, event = isTouchDevice() ? "touchstart" : "click";
        element.on(event, function (e) {
            if ("A" === element[0].tagName); else if ("function" == typeof o.onClick)o.onClick(element); else if ("function" == typeof window[o.onClick])window[o.onClick](element); else {
                var result = eval("(function(){" + o.onClick + "})");
                result.call(element)
            }
        })
    },
    _createLiveTile: function () {
        var a = this, b = this.element, c = (this.options, isTouchDevice() ? "touchstart" : "mouseenter"), d = isTouchDevice() ? "touchend" : "mouseleave";
        return this._frames = b.find(".live-slide"), this._frames.length <= 1 ? !1 : ($.easing.doubleSqrt = function (a) {
            return Math.sqrt(Math.sqrt(a))
        }, this._size = {width: b.width(), height: b.height()}, b.on(c, function () {
            a.stop()
        }), b.on(d, function () {
            a.start()
        }), void this.start())
    },
    start: function () {
        var a = this;
        this._interval = setInterval(function () {
            a._animate()
        }, this.options.period)
    },
    stop: function () {
        clearInterval(this._interval)
    },
    _animate: function () {
        var a, b = this._frames[this._currentIndex];
        switch (this._currentIndex += 1, this._currentIndex >= this._frames.length && (this._currentIndex = 0), a = this._frames[this._currentIndex], this.options.effect) {
            case"slideLeft":
                this._effectSlideLeft(b, a);
                break;
            case"slideRight":
                this._effectSlideRight(b, a);
                break;
            case"slideDown":
                this._effectSlideDown(b, a);
                break;
            case"slideUpDown":
                this._effectSlideUpDown(b, a);
                break;
            case"slideLeftRight":
                this._effectSlideLeftRight(b, a);
                break;
            default:
                this._effectSlideUp(b, a)
        }
    },
    _effectSlideLeftRight: function (a, b) {
        this._currentIndex % 2 === 0 ? this._effectSlideLeft(a, b) : this._effectSlideRight(a, b)
    },
    _effectSlideUpDown: function (a, b) {
        this._currentIndex % 2 === 0 ? this._effectSlideUp(a, b) : this._effectSlideDown(a, b)
    },
    _effectSlideUp: function (a, b) {
        var c = this._size.height, d = {duration: this.options.duration, easing: this.options.easing};
        $(a).animate({top: -c}, d), $(b).css({top: c}).show().animate({top: 0}, d)
    },
    _effectSlideDown: function (a, b) {
        var c = this._size.height, d = {duration: this.options.duration, easing: this.options.easing};
        $(a).animate({top: c}, d), $(b).css({top: -c}).show().animate({top: 0}, d)
    },
    _effectSlideLeft: function (a, b) {
        var c = this._size.width, d = {duration: this.options.duration, easing: this.options.easing};
        $(a).animate({left: -1 * c}, d), $(b).css({left: c}).show().animate({left: 0}, d)
    },
    _effectSlideRight: function (a, b) {
        var c = this._size.width, d = {duration: this.options.duration, easing: this.options.easing};
        $(a).animate({left: c}, d), $(b).css({left: -c}).show().animate({left: 0}, d)
    },
    _createTransformTile: function () {
        var a = this.element, b = (this.options, {
            w: a.width(),
            h: a.height()
        }), c = isTouchDevice() ? "touchstart" : "mousedown", d = isTouchDevice() ? "touchend" : "mouseup", e = isTouchDevice() ? "touchend" : "mouseleave";
        a.on(c, function (c) {
            var d = c.pageX - $(this).offset().left, e = c.pageY - $(this).offset().top, f = "top";
            d < 1 * b.w / 3 && (e < 1 * b.h / 2 || e > 1 * b.h / 2) ? f = "left" : d > 2 * b.w / 3 && (e < 1 * b.h / 2 || e > 1 * b.h / 2) ? f = "right" : d > 1 * b.w / 3 && d < 2 * b.w / 3 && e > b.h / 2 && (f = "bottom"), $(this).addClass("tile-transform-" + f), "A" === a[0].tagName && a.attr("href") && setTimeout(function () {
                document.location.href = a.attr("href")
            }, 500)
        }), a.on(d, function () {
            $(this).removeClass("tile-transform-left").removeClass("tile-transform-right").removeClass("tile-transform-top").removeClass("tile-transform-bottom")
        }), a.on(e, function () {
            $(this).removeClass("tile-transform-left").removeClass("tile-transform-right").removeClass("tile-transform-top").removeClass("tile-transform-bottom")
        })
    },
    _destroy: function () {
    },
    _setOption: function (a, b) {
        this._super("_setOption", a, b)
    }
}), $.widget("metro.fitImage", {
    version: "3.0.0",
    options: {shadow: !1, overlay: !1, type: "default", frameColor: "default", format: "hd"},
    _create: function () {
        var a, b, c, d, e, f = this.element, g = this.options, h = f.parent(), i = f.attr("src");
        $.each(f.data(), function (a, b) {
            if (a in g)try {
                g[a] = $.parseJSON(b)
            } catch (c) {
                g[a] = b
            }
        }), $("<img/>").attr("src", i).load(function () {
            a = this.width, b = this.height
        }).remove();
        var j = $("<div/>").addClass("image-container").css("width", "100%").appendTo(h), k = $("<div/>").addClass("frame").appendTo(j);
        switch (c = k.innerWidth(), d = k.innerHeight(), g.format) {
            case"sd":
                d = 3 * c / 4;
                break;
            case"square":
                d = c;
                break;
            case"cycle":
                d = c;
                break;
            case"fill-h":
                d = "100%", j.css("height", "100%");
                break;
            case"fill":
                d = "100%", j.css("height", "100%");
                break;
            default:
                d = 9 * c / 16
        }
        if (e = $("<div/>").css({
                width: "100%",
                height: d,
                "background-image": "url(" + i + ")",
                "background-size": "cover",
                "background-repeat": "no-repeat",
                "border-radius": "cycle" === g.format ? "50%" : "0"
            }), $(window).on("resize", function () {
                var a = k.innerWidth(), b = k.innerHeight();
                switch (g.format) {
                    case"sd":
                        b = 3 * a / 4;
                        break;
                    case"square":
                        b = a;
                        break;
                    case"cycle":
                        b = a;
                        break;
                    case"fill-h":
                        b = "100%", j.css("height", "100%");
                        break;
                    case"fill":
                        b = "100%", j.css("height", "100%");
                        break;
                    default:
                        b = 9 * a / 16
                }
                e.css({height: b})
            }), "default" !== g.frameColor && (g.frameColor.isUrl() ? k.css("background-color", g.frameColor) : k.addClass(g.frameColor)), g.overlay !== !1) {
            $("<div/>").addClass("image-overlay").html(g.overlay).appendTo(j)
        }
        switch (g.shadow !== !1 && j.addClass("block-shadow"), e.appendTo(k), g.type) {
            case"diamond":
                j.addClass("diamond"), e.addClass("image-replacer");
                break;
            case"bordered":
                j.addClass("bordered");
                break;
            case"polaroid":
                j.addClass("polaroid");
                break;
            case"handing":
                j.addClass("handing");
                break;
            case"handing-ani":
                j.addClass("handing ani");
                break;
            case"handing-ani-hover":
                j.addClass("handing ani-hover")
        }
        j.addClass("image-format-" + g.format), f.remove()
    },
    _destroy: function () {
    },
    _setOption: function (a, b) {
        this._super("_setOption", a, b)
    }
}), $.Metro = {}, $.Metro.initWidgets = function () {
    var a = $("[data-role]");
    $.each(a, function () {
        var a = $(this), b = a.data("role").split(/\s*,\s*/);
        b.map(function (b) {
            try {
                void 0 !== $.fn[b] && a.data(b + "-initiated") !== !0 && ($.fn[b].call(a), a.data(b + "-initiated", !0))
            } catch (c) {
                window.METRO_DEBUG && console.log(c.message, c.stack)
            }
        })
    })
};